const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const menu_categories = sequelize.define(
    'menu_categories',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

category_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"nourriture",


"boisson"

        ],

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

sort_order: {
        type: DataTypes.INTEGER,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  menu_categories.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity













    db.menu_categories.hasMany(db.menu_items, {
      as: 'menu_items_menu_category',
      foreignKey: {
          name: 'menu_categoryId',
      },
      constraints: false,
    });

















//end loop



    db.menu_categories.belongsTo(db.restaurants, {
      as: 'restaurant',
      foreignKey: {
        name: 'restaurantId',
      },
      constraints: false,
    });




    db.menu_categories.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.menu_categories.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return menu_categories;
};


